C        PROGRAM PARAMETER_R1
C
C       ===================================================
C       Purpose: This program computes the values of the
C       R1 & R2 funcions given by Trivedi for needle growth 
C       ===================================================
C
C       Copyright Pedro Rivera and H. K. D. H. Bhadeshia,
C       University of Cambridge, 1999
C

       IMPLICIT DOUBLE PRECISION (A-H,O-Y),INTEGER(I,J,L)
       DOUBLE PRECISION N1,N2,M12,M1,SDM1,SM,F1,F2
       DOUBLE PRECISION CN1,CN2,G12,CG1,IN1,IN2
       DOUBLE PRECISION CO,M32,PA1,PA2,R1,R2
       PI=3.141592653589793D0           
       OU1 = 1
       OU1 = 2
       OPEN(UNIT = OU1,FILE='res1.d')
       OPEN(UNIT = OU2,FILE='res2.d')


       CALL GAMMA(0.5D0,G12)

       DO 5 JJ=0,20
       N1=0.0D0
       N2=0.0D0
       P=1.0D0+0.1D0*JJ
       
       DO 10 I=0,100000000

       M12=I+0.50D0
       M1=I+1.0D0
       M32=I+1.50D0
       SDM1=0.0D0
       SM=0.0D0
       CN1=2.0D0*I
       CN2=2.0D0*I+1.0D0

         IF (M1.LE.7.0D0)THEN
           CALL GAMMA(M1,GM1)
         ELSE
           CALL LGAMA(1,M1,GM1)
         ENDIF
         IF (M32.LE.7.0D0)THEN
           CALL GAMMA(M32,GM32)
         ELSE
           CALL LGAMA(1,M32,GM32)
         ENDIF
         DO 20 II=1,I
           SDM1=SDM1+DLOG(2.0D0*II-1.0D0)
           SM=SM+DLOG(1.0d0*II)
20       CONTINUE
         CG1=DEXP(SDM1-SM-I*DLOG(2.0d0))*G12
       CALL ERROR(P**(0.50D0),ERR)
       ERFC=1.0D0-ERR

       IF (I.EQ.0) THEN
         IN2=(2.0D0/(PI**0.5D0))*DEXP(-P)
         IN1=ERFC
         IN2=((-P**(0.50D0))/CN2)*IN1+(1.0D0/(2.0D0*CN2))*IN2
       ELSE
         IN1=((-P**(0.50D0))/CN1)*IN2+(1.0D0/(2.0D0*CN1))*IN1
         IN2=((-P**(0.50D0))/CN2)*IN1+(1.0D0/(2.0D0*CN2))*IN2
        ENDIF

       CO=I*1.0D0
       CALL CHGU(M1,1.0d0,P,F,A,B,MD)
       CALL CHGU(M1,2.0d0,P,A,F1,F2,MD)

       PA1=2.0D0*P**1.5D0*DEXP(P)*CG1*2.0D0**(2.0D0*I)*GM1*IN1
&      *((I*1.0D0)*F1+F2)/F
       N1=N1+PA1
       PA2=4.0D0*P**2.0D0*DEXP(P)*2**(2.0d0*I+1.0D0)*GM32*
&      IN2*((I*1.0D0)*F1+F2)/F+PA1
       N2=N2+PA2 

C      THE FOLLOWING IF SETS THE PRECISION OF THE CALCUATION,
C      AN INCREASE OF IT MAY CAUSE NOT TO FIND A CONVERGENT
C      SOLUTION

       IF (((PA1/N1).LT.1.0D-7).AND.((PA2/N2)
&      .LT.1.0D-7)) THEN
         R1=(1.0D0/(2.0D0*P))*N1-1
         R2=(1.0D0/(4.0D0*P))*N2-1
         GOTO 30
       ENDIF
10     CONTINUE

30     WRITE(OU1,200)P,N1,N2
       WRITE(OU2,200)P,R1,R2

5      CONTINUE     

200    FORMAT(1X,4D15.6)
999    STOP
       END

        SUBROUTINE ERROR(X,ERR)
C
C       =========================================
C       Purpose: Compute error function erf(x)
C       Input:   x   --- Argument of erf(x)
C       Output:  ERR --- erf(x)
C       =========================================
C
        IMPLICIT DOUBLE PRECISION (A-H,O-Z)
        EPS=1.0D-15
        PI=3.141592653589793D0
        X2=X*X
        IF (DABS(X).LT.3.5D0) THEN
           ER=1.0D0
           R=1.0D0
           DO 10 K=1,50
              R=R*X2/(K+0.5D0)
              ER=ER+R
              IF (DABS(R).LE.DABS(ER)*EPS) GO TO 15
10         CONTINUE
15         C0=2.0D0/DSQRT(PI)*X*DEXP(-X2)
           ERR=C0*ER
        ELSE
           ER=1.0D0
           R=1.0D0
           DO 20 K=1,12
              R=-R*(K-0.5D0)/X2
20            ER=ER+R
           C0=DEXP(-X2)/(DABS(X)*DSQRT(PI))
           ERR=1.0D0-C0*ER
           IF (X.LT.0.0) ERR=-ERR
        ENDIF
        RETURN
        END

        SUBROUTINE GAMMA(X,GA)
C
C       ==================================================
C       Purpose: Compute the gamma function (x)
C       Input :  x  --- Argument of (x)
C                       ( x is not equal to 0,-1,-2, )
C       Output:  GA --- (x)
C       ==================================================
C
        IMPLICIT DOUBLE PRECISION (A-H,O-Z)
        DIMENSION G(26)
        PI=3.141592653589793D0
        IF (X.EQ.INT(X)) THEN
           IF (X.GT.0.0D0) THEN
              GA=1.0D0
              M1=X-1
              DO 10 K=2,M1
10               GA=GA*K
           ELSE
              GA=1.0D+300
           ENDIF
        ELSE
           IF (DABS(X).GT.1.0D0) THEN
              Z=DABS(X)
              M=INT(Z)
              R=1.0D0
              DO 15 K=1,M
15               R=R*(Z-K)
              Z=Z-M
           ELSE
              Z=X
           ENDIF
           DATA G/1.0D0,0.5772156649015329D0,
     &          -0.6558780715202538D0, -0.420026350340952D-1,
     &          0.1665386113822915D0,-.421977345555443D-1,
     &          -.96219715278770D-2, .72189432466630D-2,
     &          -.11651675918591D-2, -.2152416741149D-3,
     &          .1280502823882D-3, -.201348547807D-4,
     &          -.12504934821D-5, .11330272320D-5,
     &          -.2056338417D-6, .61160950D-8,
     &          .50020075D-8, -.11812746D-8,
     &          .1043427D-9, .77823D-11,
     &          -.36968D-11, .51D-12,
     &          -.206D-13, -.54D-14, .14D-14, .1D-15/
           GR=G(26)
           DO 20 K=25,1,-1
20            GR=GR*Z+G(K)
           GA=1.0D0/(GR*Z)
           IF (DABS(X).GT.1.0D0) THEN
              GA=GA*R
              IF (X.LT.0.0D0) GA=-PI/(X*GA*DSIN(PI*X))
           ENDIF
        ENDIF
        RETURN
        END


        SUBROUTINE LGAMA(KF,X,GL)
C
C       ==================================================
C       Purpose: Compute gamma function (x) or ln[(x)]
C       Input:   x  --- Argument of (x) ( x > 0 )
C                KF --- Function code
C                       KF=1 for (x); KF=0 for ln[(x)]
C       Output:  GL --- (x) or ln[(x)]
C       ==================================================
C
        IMPLICIT DOUBLE PRECISION (A-H,O-Z)
        DIMENSION A(10)
        DATA A/8.333333333333333D-02,-2.777777777777778D-03,
     &         7.936507936507937D-04,-5.952380952380952D-04,
     &         8.417508417508418D-04,-1.917526917526918D-03,
     &         6.410256410256410D-03,-2.955065359477124D-02,
     &         1.796443723688307D-01,-1.39243221690590D+00/
        X0=X
        IF (X.EQ.1.0.OR.X.EQ.2.0) THEN
           GL=0.0D0
           GO TO 20
        ELSE IF (X.LE.7.0) THEN
           N=INT(7-X)
           X0=X+N
        ENDIF
        X2=1.0D0/(X0*X0)
        XP=6.283185307179586477D0
        GL0=A(10)
        DO 10 K=9,1,-1
10         GL0=GL0*X2+A(K)
        GL=GL0/X0+0.5D0*DLOG(XP)+(X0-.5D0)*DLOG(X0)-X0
        IF (X.LE.7.0) THEN
           DO 15 K=1,N
              GL=GL-DLOG(X0-1.0D0)
15            X0=X0-1.0D0
        ENDIF
20      IF (KF.EQ.1) GL=DEXP(GL)
        RETURN
        END


        SUBROUTINE CHGU(A,B,X,F,F1,F2,ID)
C
C       ======================================================
C       Purpose: Compute confluent hypergeometric function
C                U(a,b,x) with integer b ( b = 1,2,... )
C       Input  : a  --- Parameter
C                b  --- Parameter
C                x  --- Argument
C       Output:  HU --- U(a,b,x)
C                ID --- Estimated number of significant digits
C       Routines called:
C            (1) GAMMA for computing gamma function (x)
C            (2) PSI for computing psi function
C       ======================================================
C
        IMPLICIT DOUBLE PRECISION (A-H,O-Z)
        DOUBLE PRECISION F1,F2
        ID=-100
        EL=0.5772156649015329D0
        N=ABS(B-1)
        RN1=1.0D0
        RN=1.0D0
        DO 10 J=1,N
           RN=RN*J
           IF (J.EQ.N-1) RN1=RN
10      CONTINUE
        CALL PSI(A,PS)
        CALL GAMMA(A,GA)
        IF (B.GT.0.0) THEN
           A0=A
           A1=A-N
           A2=A1
           CALL GAMMA(A1,GA1)
c           UA=(-1)**(N-1)/(RN*GA1)
c           UB=RN1/GA*X**(-N)
           UA=(-1)**(N-1)/(RN*1.0D0)
           UB=RN1/1.0D0*X**(-N)
        ELSE
           A0=A+N
           A1=A0
           A2=A
           CALL GAMMA(A1,GA1)
           UA=(-1)**(N-1)/(RN*GA)*X**N
           UB=RN1/GA1
        ENDIF
        HM1=1.0D0
        R=1.0D0
        HMAX=0.0D0
        HMIN=1.0D+300
        DO 15 K=1,150
           R=R*(A0+K-1.0D0)*X/((N+K)*K)
           HM1=HM1+R
           HU1=DABS(HM1)
           IF (HU1.GT.HMAX) HMAX=HU1
           IF (HU1.LT.HMIN) HMIN=HU1
           IF (DABS(HM1-H0).LT.DABS(HM1)*1.0D-15) GO TO 20
15         H0=HM1
20      DA1=LOG10(HMAX)
        IF (HMIN.NE.0.0) DA2=LOG10(HMIN)
        ID=15-ABS(DA1-DA2)
        HM1=HM1*DLOG(X)
        S0=0.0D0
        DO 25 M=1,N
           IF (B.GE.0.0) S0=S0-1.0D0/M
25         IF (B.LT.0.0) S0=S0+(1.0D0-A)/(M*(A+M-1.0D0))
        HM2=PS+2.0D0*EL+S0
        R=1.0D0
        HMAX=0.0D0
        HMIN=1.0D+300
        DO 50 K=1,150
           S1=0.0D0
           S2=0.0D0
           IF (B.GT.0.0) THEN
              DO 30 M=1,K
30               S1=S1-(M+2.0D0*A-2.0D0)/(M*(M+A-1.0D0))
              DO 35 M=1,N
35               S2=S2+1.0D0/(K+M)
           ELSE
              DO 40 M=1,K+N
40               S1=S1+(1.0D0-A)/(M*(M+A-1.0D0))
              DO 45 M=1,K
45               S2=S2+1.0D0/M
           ENDIF
           HW=2.0D0*EL+PS+S1-S2
           R=R*(A0+K-1.0D0)*X/((N+K)*K)
           HM2=HM2+R*HW
           HU2=DABS(HM2)
           IF (HU2.GT.HMAX) HMAX=HU2
           IF (HU2.LT.HMIN) HMIN=HU2
           IF (DABS((HM2-H0)/HM2).LT.1.0D-15) GO TO 55
50         H0=HM2
55      DB1=LOG10(HMAX)
        IF (HMIN.NE.0.0) DB2=LOG10(HMIN)
        ID1=15-ABS(DB1-DB2)
        IF (ID1.LT.ID) ID=ID1
        HM3=1.0D0
        IF (N.EQ.0) HM3=0.0D0
        R=1.0D0
        DO 60 K=1,N-1
           R=R*(A2+K-1.0D0)/((K-N)*K)*X
60         HM3=HM3+R
        SA=UA*(HM1+HM2)
        SB=UB*HM3
        HU=SA+SB
        F=SA+SB
        F1=SA
        F2=SB
c        WRITE(*,200)F,F1,F2
        IF (SA.NE.0.0) ID1=INT(LOG10(ABS(SA)))
        IF (HU.NE.0.0) ID2=INT(LOG10(ABS(HU)))
        IF (SA*SB.LT.0.0) ID=ID-ABS(ID1-ID2)
200    FORMAT(1X,4D15.5)

        RETURN
        END

        SUBROUTINE PSI(X,PS)
C
C       ======================================
C       Purpose: Compute Psi function
C       Input :  x  --- Argument of psi(x)
C       Output:  PS --- psi(x)
C       ======================================
C
        IMPLICIT DOUBLE PRECISION (A-H,O-Z)
        XA=DABS(X)
        PI=3.141592653589793D0
        EL=.5772156649015329D0
        S=0.0D0
        IF (X.EQ.INT(X).AND.X.LE.0.0) THEN
           PS=1.0D+300
           RETURN
        ELSE IF (XA.EQ.INT(XA)) THEN
           N=XA
           DO 10 K=1 ,N-1
10            S=S+1.0D0/K
           PS=-EL+S
        ELSE IF (XA+.5.EQ.INT(XA+.5)) THEN
           N=XA-.5
           DO 20 K=1,N
20            S=S+1.0/(2.0D0*K-1.0D0)
           PS=-EL+2.0D0*S-1.386294361119891D0
        ELSE
           IF (XA.LT.10.0) THEN
              N=10-INT(XA)
              DO 30 K=0,N-1
30               S=S+1.0D0/(XA+K)
              XA=XA+N
           ENDIF
           X2=1.0D0/(XA*XA)
           A1=-.8333333333333D-01
           A2=.83333333333333333D-02
           A3=-.39682539682539683D-02
           A4=.41666666666666667D-02
           A5=-.75757575757575758D-02
           A6=.21092796092796093D-01
           A7=-.83333333333333333D-01
           A8=.4432598039215686D0
           PS=DLOG(XA)-.5D0/XA+X2*(((((((A8*X2+A7)*X2+
     &        A6)*X2+A5)*X2+A4)*X2+A3)*X2+A2)*X2+A1)
           PS=PS-S
        ENDIF
        IF (X.LT.0.0) PS=PS-PI*DCOS(PI*X)/DSIN(PI*X)-1.0D0/X
        RETURN
        END

